function fabso(pred,posneg,xpr)

%This function implements SOARD rule self-organization based on a given
%prediction and the experience status.

global wrltemp div nwrltemp

ncat=length(pred);
bn=0.5;                 %Rule self-organization inhibition coefficient
maxXP=6*ncat;           %Maximum experience value

if length(find(pred~=0))>0  %& length(find(pred~=0))<=4
    for ii=1:ncat
        for jj=1:ncat
            if ii~=jj
               
                xP=(max(xpr(ii),0)+max(xpr(jj),0))/(2*maxXP);               %Rule XP is the joint XP of the corresponding nodes
                %xP=(max(xpr(ii),0)*max(xpr(jj),0))/(maxXP)^2;

                nwrltemp(ii,jj)=nwrltemp(ii,jj)+bn*xP*min(pred(ii),~pred(jj));  %Hebbiean inhibitory
                %nwrltemp(ii,jj)=nwrltemp(ii,jj)+bn*min(pred(ii),~pred(jj));
                
                wrltemp(ii,jj)=wrltemp(ii,jj)+xP*min(pred(ii),pred(jj));        %Hebbian excitatory
                %wrltemp(ii,jj)=wrltemp(ii,jj)+min(pred(ii),pred(jj));
                div(ii,jj)=div(ii,jj)+pred(ii);                                 %Homeostatic

            end;
        end;
    end;
end;
