function [prediH,prediValH,yselH]=ppf(predoH)
%
%function [prediH,prediValH,yselH]=ppf(predoH)
%
%PPF implements the per-pixel filtering function. It receives the original
%distributed prediction (predoH) and returns:
%prediH:    Binarized PPFd prediction
%prediValH: PPFd distributed prediction without binarizing
%yselH:     Vector with surviving classes after PPF. Classes are ordered
%           are ordered from lower to higher original activation in Fab.
%

ncat=length(predoH);                    %Length of prediction

[prueba2,index]=sortrows(predoH);       %Order elements in prediction
ind=index;                              %Position among the ordered Zks
prx=prueba2;                            %Actual Zk values ordered
tr=circshift(prueba2,1);
tr(1)=prueba2(1);
dif=prueba2-tr;
%dif=dif./prueba2;
%dif(find(prueba2==0))=0;
[what,where]=max(dif);

if where < ncat-4                       %Maximum number of predictions x+1
    where = ncat-4;
end;

prueba2(1:where-1)=0;
index(1:where-1)=0;
nsigma=prueba2';                        %Value of the correct predicted nodes are the only non-zero values
clases=index';                          %Correct predicted node positions are the only non-zero values

prediH=zeros(1,ncat);                   %Initialize returned variables
prediValH=prediH;

yselH=clases(find(clases~=0));          %Gets rid of the zeros leaving only predicted classes

%Binarizing...
for kk=1:length(yselH)
    prediH(yselH(kk))=1; %predi(find(wjk(ysel(kk),:)~=0))+valor(kk);  %1; %predi(find(wjk(ysel(kk),:)~=0))+1;
    prediValH(yselH(kk))=predoH(yselH(kk)); %predi(find(wjk(ysel(kk),:)~=0))+valor(kk);  %1; %predi(find(wjk(ysel(kk),:)~=0))+1;
end;
